import { LRParser } from '@lezer/lr';
import { LRLanguage, LanguageSupport } from '@codemirror/language';
import { styleTags, tags } from '@codemirror/highlight';
import { completeFromList } from '@codemirror/autocomplete';

// This file was generated by lezer-generator. You probably shouldn't edit it.
const parser = LRParser.deserialize({
  version: 13,
  states: "!jOVQPOOO_QPO'#CgOOQO'#Cg'#CgQOQPOOOmQPO,58{OxQPO'#ChO!QQPO1G.gOVQPO'#CcO!VQPO,59SOOQO7+$R7+$ROOQO,58},58}OOQO-E6a-E6a",
  stateData: "!_~OYOS~OQQORPO~OUSOWZXSZX]ZX~OQQORPOS[P~O]VOS[X~OSXO~O]VOS[a~O",
  goto: "u]PPPPP^PcPPPirVQOSVQWTRZWQROQTSRYVRUS",
  nodeNames: "⚠ Program String Identifier ) Application (",
  maxTerm: 13,
  skippedNodes: [0],
  repeatNodeCount: 1,
  tokenData: "#o~R]XYzYZz]^zpqzrs!]xy!zyz#P|}#U}!O#Z!Q![#Z!c!}#Z#R#S#Z#T#o#Z~!PSY~XYzYZz]^zpqz~!`TOr!]rs!os#O!]#O#P!t#P~!]~!tOQ~~!wPO~!]~#POU~~#UOS~~#ZO]~~#`TR~}!O#Z!Q![#Z!c!}#Z#R#S#Z#T#o#Z",
  tokenizers: [0],
  topRules: {"Program":[0,1]},
  tokenPrec: 0
});

const BSLanguage = LRLanguage.define({
    parser: parser.configure({
        props: [
            styleTags({
                Identifier: tags.variableName,
                String: tags.string,
                "( )": tags.paren
            })
        ]
    }),
    languageData: {
        closeBrackets: { brackets: ['('] }
    }
});
const bslangCompletion = BSLanguage.data.of({
    autocomplete: completeFromList([
        { label: "avg", type: "function" },
        { label: "sum", type: "function" },
        { label: "zSpread", type: "function" },
        { label: "CB.BTC.USD", type: "variable" },
        { label: "CB.DOGE.RUB", type: "variable" },
    ])
});
function BSLANG() {
    return new LanguageSupport(BSLanguage, [bslangCompletion]);
}

export { BSLANG, BSLanguage, bslangCompletion };
